
;        * G a l a c t i c
;
;            by pacHa
;      [pacHa-@wanadoo.fr]
;      [some_asm@hotmail.com]
;      [pacha07@caramail.com]


; Please DO_NOT_MODIFY this game without my permission.

; This game uses 2 times self-modifying code for space optimisations.

; Controls
;  - [(up)] and [(down)] : move ship (with 'clipping')
;  - [MODE] : quit at any time

; Features
;  - ship with grayscale smoke
;  - variable size of the asteroids coming
;  - the game becomes harder and harder
;  - very small (only 382 bytes on calc!)

; Credits
;  - CrASH_MAN for his Scroll_L routine
;  - movax for his XOR sprite routine
; Please note that I've modified these 2 routines for optimisations.

; If you like this game or you can help me to port it to 83+,
; drop me a line (suggestions, bugs, comments) at
; pacHa-@wanadoo.fr

; Enjoy !

; last modified 02/21/2003 (m/d/y) (port to 83) - 382 bytes

#include	ion.inc


	.org progstart
	ret
	jr nc,Start


.db	$cd,"Galactic",0


#define	SH_BUF	saferam5
#define	CR_GRBCopy	ionFastCopy
#define	GET_RAND	ionRandom
#define	HL_DECI	_disphl
#define	PAUSE	_getkey
#define	GRAPH_MEM	plotsscreen
#define	CURSOR_POS	currow

Start:

pos_y		=	SH_BUF
score		=	SH_BUF + 1
time_		=	SH_BUF + 3
time_level	=	SH_BUF + 4


	ld	a,28
	ld	(pos_y),a
	xor	a
	ld	(score),a
	ld	(score+1),a
	ld	(time_level),a
	ld	a,7
	ld	(__level+1),a


loop:
	ld	hl,(score)
	inc	hl
	ld	(score),hl
	ld	hl,time_
	inc	(hl)
	ld	a,(time_level)
	cp	192
	call	z,get_harder
	inc	a
	ld	(time_level),a
	bcall(GET_RAND)
__level:
	cp	7		; the '7' may be modified
	call	c,newblock
	jr	_check
_aftercheck:
	call	putship
	call	put_smoke
	bcall(CR_GRBCopy)
	call	putship
	call	Scroll_L

	ld	a,$ff
	out	($01),a
	ld	a,$bf
	out	($01),a
	in	a,($01)
	bit	6,a
	ret	z
	ld	a,$fe
	out	($01),a
	in	a,($01)
	bit	0,a
	jr	z,down
	bit	3,a
	jr	z,up
	jr	loop

up:
	ld	a,(pos_y)
	or	a
	jr	z,_down
	dec	a
	dec	a
	ld	(pos_y),a
down:
	ld	a,(pos_y)
	cp	59
	jr	z,_up
	inc	a
	ld	(pos_y),a
	jr	loop

_down:
	ld	a,58
	ld	(pos_y),a
	jr	loop

_up:
	ld	a,1
	ld	(pos_y),a
	jr	loop

_check:
	ld	a,(pos_y)
	ld	e,a
	ld	a,16
	call	calc
	ld	b,4
_c_loop:
	ld	a,(hl)
	or	a		; detect collision
	jr	nz,_end
	ld	de,12
	add	hl,de
	djnz	_c_loop
	jr	_aftercheck

get_harder:
	xor	a
	ld	(time_level),a
	ld	hl,__level+1		; self-modifying code
	inc	(hl)				;
	ret

newblock:
	bcall(GET_RAND)
	and	%00000111
	inc	a
	inc	a
	ld	d,a
__randblock:
	bcall(GET_RAND)
	cp	56
	jr	nc,__randblock
	ld	e,a
	ld	a,88
	ld	bc,block
	jr	PutSprite
	;ret

putship:
	ld	a,5
	ld	d,a
	ld	a,(pos_y)
	ld	e,a
	ld	a,16
	push	af
	ld	a,(time_)
	bit	3,a
	jr	z,second_ship
	ld	bc,ship
_putship:
	pop	af
	jr	PutSprite
	;ret
second_ship:
	ld	bc,ship_gray
	jr	_putship

put_smoke:
	ld	a,3
	ld	d,a
	ld	a,(pos_y)
	inc	a
	ld	e,a
	ld	a,8
	ld	bc,smoke
	call	PutSprite
	ld	hl,smoke
	rrc	(hl)
	inc	hl
	rrc	(hl)
	inc	hl
	rrc	(hl)
	ret

_end:
	ld	hl,$0007
	ld	(CURSOR_POS),hl
	ld	hl,(score)
	bcall(HL_DECI)
	;CALL	D_ZT_STR
   jp	PAUSE
	;ret

block:
	.db	%00010110
	.db	%00110110
	.db	%01101011
	.db	%10010110
	.db	%01100101
	.db	%00101101
	.db	%10101100
	.db	%10010101
	.db	%01101001
	.db	%00110101

ship:
	.db	%11110000
	.db	%01101110
	.db	%10110111
	.db	%01101110
	.db	%11110000

ship_gray:
	.db	%00110000
	.db	%00001110
	.db	%00011111
	.db	%00001110
	.db	%00110000

smoke:
	.db	%00000010
	.db	%00000100
	.db	%00000001


Scroll_L:		;*** modified routine from CrASH_MAN
	ld	hl,GRAPH_MEM+767
	ld	b,64
_LLoop:
	sla	(hl)
	push	bc
	ld	b,11
repeat:
	dec	hl
	rl	(hl)
	djnz	repeat
	pop	bc
	dec	hl
	djnz	_LLoop
	ret


PutSprite:		;*** modified routine from movax
	push	af
	ld	a,d
	ld	(__times+1),a	; self-modifying code
	pop	af
	push	bc
	call	calc
	pop	de
__times:
	ld	b,8			; the '8' may be modified
_sprite_repeat:
	ld	a,(de)
	xor	(hl)
	ld	(hl),a
	inc	de
	push	bc
	ld	bc,12
	add	hl,bc
	pop	bc
	djnz	_sprite_repeat
	ret
calc:
	ld	hl,0
	ld	d,0
	add	hl,de
	add	hl,de
	add	hl,de
	add	hl,hl
	add	hl,hl
	ld	d,0
	ld	e,a
	srl	e
	srl	e
	srl	e
	add	hl,de
	ld	de,GRAPH_MEM
	add	hl,de
	ret

.end
END